
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpi project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpi
 *
 * This file was automatically generated by the sierpinski code generator
 */


char V_e_bbb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bnb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_bbo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bnb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bbn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_nob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_bbn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bnb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_nbo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_nbo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_onn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_bon_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_onn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_nno_backward((hyp_normal+5)&7, depth+1);
		if (V_o_noo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(-1);
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_nno_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_onn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_non_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_non_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_onn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_nno_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_onn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_non_backward((hyp_normal+3)&7, depth+1);
		if (V_e_noo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(-1);
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_noo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_onn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_ono_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_ono_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_oon_backward((hyp_normal+3)&7, depth+1);
		if (V_e_noo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_oon_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_ono_backward((hyp_normal+5)&7, depth+1);
		if (V_o_noo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_noo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_onn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_oon_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_bon_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_onb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_nbo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_onb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bon_backward((hyp_normal+3)&7, depth+1);
		if (V_e_noo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_nob_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_onn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_bno_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bno_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_obn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_nob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_obn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bno_backward((hyp_normal+5)&7, depth+1);
		if (V_o_noo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bbo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_obn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_bob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_bob_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_onb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_bbo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bbb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bbn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_bob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_nnn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_nnn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_nno_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->push(-1);
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_nnn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_nnn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_non_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->push(-1);
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_ooo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_ono_backward((hyp_normal+5)&7, depth+1);
		if (V_o_ooo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_ooo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_oon_backward((hyp_normal+3)&7, depth+1);
		if (V_e_ooo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_bnn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_nnb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_nbo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(-1);
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(0);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_nnb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bnn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_non_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bnn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_nbn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_nob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(-1);
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(0);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_nbn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bnn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_nno_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_boo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_onb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_obo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_obo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_oon_backward((hyp_normal+3)&7, depth+1);
		if (V_e_boo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_boo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_obn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_oob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_oob_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_ono_backward((hyp_normal+5)&7, depth+1);
		if (V_o_boo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_nbn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_nnn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_bon_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_obo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bno_backward((hyp_normal+5)&7, depth+1);
		if (V_o_ooo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_nnb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_nnn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_bno_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_oob_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bon_backward((hyp_normal+3)&7, depth+1);
		if (V_e_ooo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bbn_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_nbn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_bob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_bbo_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bnb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_obo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_nbb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bnn_backward((hyp_normal+5)&7, depth+1);
		if (V_o_bno_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->push(0);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_nbb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bnn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_bon_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(0);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_obb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_bno_backward((hyp_normal+5)&7, depth+1);
		if (V_o_boo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_obb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bon_backward((hyp_normal+3)&7, depth+1);
		if (V_e_boo_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_e_bnb_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_o_nnb_backward((hyp_normal+5)&7, depth+1);
		if (V_o_bbo_backward((hyp_normal+3)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *left_element = element_fifo_in.getPreviousDataPtr();
		TElementData *right_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_right_edge_stack->push(-1);
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_right_edge_stack->push(0);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_right_edge_stack->push(1);

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

char V_o_bob_backward(int hyp_normal, int depth)
{

	if (structure_stack_in->pop())
	{
	

		V_e_bbn_backward((hyp_normal+3)&7, depth+1);
		if (V_e_oob_backward((hyp_normal+5)&7, depth+1) != 0)
		{
			// no coarsening to do
			structure_stack_out->push(1);
			return 1;
		}

		// coarsening
		structure_stack_out->push(0);

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		TElementData *element_data = element_data_stack_out->fakePush_returnPtr();
		TElementData *right_element = element_fifo_in.getPreviousDataPtr();
		TElementData *left_element = element_fifo_in.getPreviousPreviousDataPtr();
		cKernelClass.coarsen(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, left_element, right_element);
		return 1;
	}
	
	// get pointer to next element
	TElementData *new_left_left_element;
	TElementData *new_left_right_element;
	TElementData *new_right_left_element;
	TElementData *new_right_right_element;
	TElementData *element_data = element_fifo_in.getNextDataPtr();

	unsigned char state = adaptivity_state_flag_stack_in->pop();
	switch(state)
	{
	case 0:
		structure_stack_out->push(0);
		element_data_stack_out->push_PtrValue(element_data);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+0))
			maxLeafTraversalDepth = depth+0;

		return 1;

	case 1:
		assert(false);
		return -1;

	case 2:	// coarsening along edge_right and edge_left => nothing to do
		comm_left_edge_stack->pop();
		return 0;

	case 3:
		assert(false);
		return -1;

	case 4:
		structure_stack_out->push(0, 0, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+1))
			maxLeafTraversalDepth = depth+1;

		return 1;

	case 5:
		structure_stack_out->push(0, 0, 1, 0, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_r(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

			return 1;

	case 6:
		structure_stack_out->push(0, 0, 0, 1, 1);
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_l_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	case 7:
		structure_stack_out->push(0, 0, 1, 0, 0, 1, 1);
		new_left_right_element = element_data_stack_out->fakePush_returnPtr();
		new_left_left_element = element_data_stack_out->fakePush_returnPtr();
		new_right_right_element = element_data_stack_out->fakePush_returnPtr();
		new_right_left_element = element_data_stack_out->fakePush_returnPtr();
		cKernelClass.refine_ll_rr(CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], depth, element_data, new_left_left_element, new_left_right_element, new_right_left_element, new_right_right_element);
		comm_left_edge_stack->pop();

		if (maxLeafTraversalDepth < (depth+2))
			maxLeafTraversalDepth = depth+2;

		return 1;

	default:
		assert(false);
		return -1;
	}
}

static const int number_of_recursion_functions = 44;
typedef char (TThisClass::*TRecursiveMethod)(int, int);
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [2] [27] [2] =
	{
	{
	{
		nullptr ,
		&TThisClass::V_e_nnn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_non_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_noo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nbn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nbb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_onn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_oon_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_ooo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_oob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_obn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_obo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_obb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bnn_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bon_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_boo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bbn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bbo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bbb_backward 
	} 
	} ,
	{
	{
		nullptr ,
		&TThisClass::V_o_nnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nno_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nnb_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_noo_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nbn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nbo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nbb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_onn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_ono_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_onb_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_ooo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_oob_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_obo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_obb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bno_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bnb_backward 
	} ,
	{
		nullptr ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_boo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bbn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bbo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bbb_backward 
	} 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

		assert(i_cTriangleFactory.edgeTypes.hyp != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.left != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.right != CTriangle_Enums::EDGE_TYPE_INVALID);
		CTriangle_Enums::EEdgeType hyp, left, right;
		if (specialMode == 0)
		{
			hyp = i_cTriangleFactory.edgeTypes.hyp;
			right = i_cTriangleFactory.edgeTypes.right;
			left = i_cTriangleFactory.edgeTypes.left;
		}
		else if (specialMode & SFC_METHOD_NEW_TO_OLD_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.left);
		}
		else if (specialMode & SFC_METHOD_OLD_TO_NEW_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.left);
		}
	#if DEBUG
		else
		{
			assert(false);
		}
	#endif
	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction];
}
