
/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpi project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpi
 *
 * This file was automatically generated by the sierpinski code generator
 */


void V_e_bbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
}

void V_o_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_e_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_o_nob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_e_onn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_non_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_o_non_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_e_nno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_o_onn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nno_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_e_noo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_oon_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_o_oon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_e_ono_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_o_noo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_ono_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_e_bno_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_o_obn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_noo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_e_nbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_o_bon_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_e_onb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_noo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_o_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_e_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_o_bbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
}

void V_e_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_o_nnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_e_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_o_ooo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_e_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_nob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_o_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_nno_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_o_bnn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_nbo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_e_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_non_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_e_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_obn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_o_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_ono_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_o_boo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_e_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_oon_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_e_nbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nnn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_o_obo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_ooo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_o_nnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nnn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_e_oob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_ooo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_e_bbn_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nbn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_bob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_o_bbo_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_obo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_e_nbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_bon_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_o_nbb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnn_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_bno_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
}

void V_e_obb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bon_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_boo_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_right_edge_stack->pop_returnPtr());
}

void V_o_obb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bno_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_boo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

void V_o_bnb_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nnb_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_e_bbo_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	TElementData *element_data = element_data_lifo.getNextDataPtr();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
}

void V_e_bob_forward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bbn_forward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_o_oob_forward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		structure_stack_out->push(1);
		return;
	}
	structure_stack_out->push(0);
	element_data_lifo.getNextDataPtr();
	edge_comm_buffer->push_PtrValue(edge_data_comm_left_edge_stack->pop_returnPtr());
}

/*
 * Copyright (C) 2011 Technische Universitaet Muenchen
 * This file is part of the Sierpi project. For conditions of distribution and
 * use, please see the copyright notice in the file 'copyright.txt' at the root
 * directory of this package and the copyright notice at http://www5.in.tum.de/sierpi
 *
 * This file was automatically generated by the sierpinski code generator
 */


void V_e_bbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_bbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_nbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_onn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nno_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_nno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_non_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_non_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_onn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_non_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_noo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_ono_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_ono_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_oon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_noo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_onn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_oon_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_bon_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_onb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_noo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_nob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bno_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_obn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_noo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_bob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_nnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nnn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_nnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nnn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_non_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_ooo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_ooo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_ooo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_bnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nnb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_nbo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_nnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_non_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bnn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nbn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_nob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_nbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_nno_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_onb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_obo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_obo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_oon_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_boo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_boo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_obn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_oob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_oob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_ono_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_boo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_nbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nnn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_obo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_ooo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_nnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nnn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_oob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_ooo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bbn_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_nbn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_bob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_bbo_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_obo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	left_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_nbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bnn_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_bno_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_left_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_nbb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bnn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_bon_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_obb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_bno_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_boo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_obb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bon_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_boo_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	hyp_edge_data = edge_data_comm_right_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &right_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_e_bnb_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_o_nnb_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		V_o_bbo_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_comm_buffer->pop_returnRef();
	cKernelClass.computeEdgeCommData_Right(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, edge_data_comm_right_edge_stack->fakePush_returnPtr());
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

void V_o_bob_backward(TVertexScalar vx0, TVertexScalar vy0, TVertexScalar vx1, TVertexScalar vy1, TVertexScalar vx2, TVertexScalar vy2, int hyp_normal)
{

	if (structure_lifo_in.getNextData())
	{
		TVertexScalar mx = (vx0+vx1)*(TVertexScalar)0.5;
		TVertexScalar my = (vy0+vy1)*(TVertexScalar)0.5;
		V_e_bbn_backward(vx2, vy2, vx0, vy0, mx, my, (hyp_normal+3)&7);
		V_e_oob_backward(vx1, vy1, vx2, vy2, mx, my, (hyp_normal+5)&7);
		return;
	}
	TElementData *element_data = element_data_fifo.getNextDataPtr();
	TEdgeData hyp_edge_data;
	TEdgeData right_edge_data;
	TEdgeData left_edge_data;
	right_edge_data = edge_data_comm_left_edge_stack->pop_returnRef();
	cKernelClass.computeBoundaryCommData_Hyp(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data);
	cKernelClass.computeBoundaryCommData_Left(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &left_edge_data);
	cKernelClass.elementAction(vx0, vy0, vx1, vy1, vx2, vy2, CTriangle_Normals::normal_table[hyp_normal][0], CTriangle_Normals::normal_table[hyp_normal][1], CTriangle_Normals::normal_table[(hyp_normal+5)&7][0], CTriangle_Normals::normal_table[(hyp_normal+5)&7][1], CTriangle_Normals::normal_table[(hyp_normal+3)&7][0], CTriangle_Normals::normal_table[(hyp_normal+3)&7][1], element_data, &hyp_edge_data, &right_edge_data, &left_edge_data);
}

static const int number_of_recursion_functions = 88;
typedef void (TThisClass::*TRecursiveMethod)(TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, TVertexScalar, int);
enum ESFCMethod{
	SFC_METHOD_DEFAULT = 0,
	SFC_METHOD_FORCE_FORWARD = (1 << 0),
	SFC_METHOD_FORCE_BACKWARD = (1 << 1),
	SFC_METHOD_NEW_TO_OLD_EDGE_TYPES = (1 << 2),
	SFC_METHOD_OLD_TO_NEW_EDGE_TYPES = (1 << 3),
	SFC_METHOD_LIMITER___ = (1 << 4)
};

template <int specialMode = 0>
TRecursiveMethod getSFCMethod(CTriangle_Factory &i_cTriangleFactory)
{
	static TRecursiveMethod methodArray [2] [27] [2] =
	{
	{
	{
		&TThisClass::V_e_nnn_forward ,
		&TThisClass::V_e_nnn_backward 
	} ,
	{
		&TThisClass::V_e_nno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nnb_forward ,
		&TThisClass::V_e_nnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_non_backward 
	} ,
	{
		&TThisClass::V_e_noo_forward ,
		&TThisClass::V_e_noo_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_nob_backward 
	} ,
	{
		&TThisClass::V_e_nbn_forward ,
		&TThisClass::V_e_nbn_backward 
	} ,
	{
		&TThisClass::V_e_nbo_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_nbb_forward ,
		&TThisClass::V_e_nbb_backward 
	} ,
	{
		&TThisClass::V_e_onn_forward ,
		&TThisClass::V_e_onn_backward 
	} ,
	{
		&TThisClass::V_e_ono_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_onb_forward ,
		nullptr 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_oon_backward 
	} ,
	{
		&TThisClass::V_e_ooo_forward ,
		&TThisClass::V_e_ooo_backward 
	} ,
	{
		&TThisClass::V_e_oob_forward ,
		&TThisClass::V_e_oob_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_obn_backward 
	} ,
	{
		&TThisClass::V_e_obo_forward ,
		&TThisClass::V_e_obo_backward 
	} ,
	{
		&TThisClass::V_e_obb_forward ,
		&TThisClass::V_e_obb_backward 
	} ,
	{
		&TThisClass::V_e_bnn_forward ,
		&TThisClass::V_e_bnn_backward 
	} ,
	{
		&TThisClass::V_e_bno_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_e_bnb_forward ,
		&TThisClass::V_e_bnb_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_e_bon_backward 
	} ,
	{
		&TThisClass::V_e_boo_forward ,
		&TThisClass::V_e_boo_backward 
	} ,
	{
		&TThisClass::V_e_bob_forward ,
		&TThisClass::V_e_bob_backward 
	} ,
	{
		&TThisClass::V_e_bbn_forward ,
		&TThisClass::V_e_bbn_backward 
	} ,
	{
		&TThisClass::V_e_bbo_forward ,
		&TThisClass::V_e_bbo_backward 
	} ,
	{
		&TThisClass::V_e_bbb_forward ,
		&TThisClass::V_e_bbb_backward 
	} 
	} ,
	{
	{
		&TThisClass::V_o_nnn_forward ,
		&TThisClass::V_o_nnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nno_backward 
	} ,
	{
		&TThisClass::V_o_nnb_forward ,
		&TThisClass::V_o_nnb_backward 
	} ,
	{
		&TThisClass::V_o_non_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_noo_forward ,
		&TThisClass::V_o_noo_backward 
	} ,
	{
		&TThisClass::V_o_nob_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_nbn_forward ,
		&TThisClass::V_o_nbn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_nbo_backward 
	} ,
	{
		&TThisClass::V_o_nbb_forward ,
		&TThisClass::V_o_nbb_backward 
	} ,
	{
		&TThisClass::V_o_onn_forward ,
		&TThisClass::V_o_onn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_ono_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_onb_backward 
	} ,
	{
		&TThisClass::V_o_oon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_ooo_forward ,
		&TThisClass::V_o_ooo_backward 
	} ,
	{
		&TThisClass::V_o_oob_forward ,
		&TThisClass::V_o_oob_backward 
	} ,
	{
		&TThisClass::V_o_obn_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_obo_forward ,
		&TThisClass::V_o_obo_backward 
	} ,
	{
		&TThisClass::V_o_obb_forward ,
		&TThisClass::V_o_obb_backward 
	} ,
	{
		&TThisClass::V_o_bnn_forward ,
		&TThisClass::V_o_bnn_backward 
	} ,
	{
		nullptr ,
		&TThisClass::V_o_bno_backward 
	} ,
	{
		&TThisClass::V_o_bnb_forward ,
		&TThisClass::V_o_bnb_backward 
	} ,
	{
		&TThisClass::V_o_bon_forward ,
		nullptr 
	} ,
	{
		&TThisClass::V_o_boo_forward ,
		&TThisClass::V_o_boo_backward 
	} ,
	{
		&TThisClass::V_o_bob_forward ,
		&TThisClass::V_o_bob_backward 
	} ,
	{
		&TThisClass::V_o_bbn_forward ,
		&TThisClass::V_o_bbn_backward 
	} ,
	{
		&TThisClass::V_o_bbo_forward ,
		&TThisClass::V_o_bbo_backward 
	} ,
	{
		&TThisClass::V_o_bbb_forward ,
		&TThisClass::V_o_bbb_backward 
	} 
	} 
	} 	;

	assert(i_cTriangleFactory.triangleType != CTriangle_Enums::TRIANGLE_TYPE_INVALID);
	assert(i_cTriangleFactory.evenOdd != CTriangle_Enums::EVEN_ODD_INVALID);

		assert(i_cTriangleFactory.edgeTypes.hyp != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.left != CTriangle_Enums::EDGE_TYPE_INVALID);
		assert(i_cTriangleFactory.edgeTypes.right != CTriangle_Enums::EDGE_TYPE_INVALID);
		CTriangle_Enums::EEdgeType hyp, left, right;
		if (specialMode == 0)
		{
			hyp = i_cTriangleFactory.edgeTypes.hyp;
			right = i_cTriangleFactory.edgeTypes.right;
			left = i_cTriangleFactory.edgeTypes.left;
		}
		else if (specialMode & SFC_METHOD_NEW_TO_OLD_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_NEW ? CTriangle_Enums::EDGE_TYPE_OLD : i_cTriangleFactory.edgeTypes.left);
		}
		else if (specialMode & SFC_METHOD_OLD_TO_NEW_EDGE_TYPES)
		{
			hyp = (i_cTriangleFactory.edgeTypes.hyp == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.hyp);
			right = (i_cTriangleFactory.edgeTypes.right == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.right);
			left = (i_cTriangleFactory.edgeTypes.left == CTriangle_Enums::EDGE_TYPE_OLD ? CTriangle_Enums::EDGE_TYPE_NEW : i_cTriangleFactory.edgeTypes.left);
		}
	#if DEBUG
		else
		{
			assert(false);
		}
	#endif
	CTriangle_Enums::EDirection direction;
	if (specialMode & SFC_METHOD_FORCE_FORWARD)
	{
		direction = CTriangle_Enums::DIRECTION_FORWARD;
	}
	else if (specialMode & SFC_METHOD_FORCE_BACKWARD)
	{
		direction = CTriangle_Enums::DIRECTION_BACKWARD;
	}
	else
	{
		direction = i_cTriangleFactory.traversalDirection;
	}

		assert(i_cTriangleFactory.traversalDirection != CTriangle_Enums::DIRECTION_INVALID);
	assert(i_cTriangleFactory.hypNormal != CTriangle_Enums::NORMAL_INVALID);
#if DEBUG
	assert(methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction] != nullptr);
#endif
	return methodArray[i_cTriangleFactory.evenOdd][hyp*9+right*3+left][direction];
}
